/*
 * Filter for displaying only twin primes.
 *
 * Copyright (C) 2004 George Gesslein II.
 *
 * Usage: matho-primes | matho-twin
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#if	UNIX
#include <libgen.h>
#endif
#include <ctype.h>
#include <string.h>
#include <errno.h>
#include <math.h>

#define	true	1
#define	false	0

void	usage(void);
int	get_double_int(char *cp, double *dp);

char	*prog_name = "matho-twin";

int
main(int argc, char *argv[])
{
	double		d1, d2;
	char		buf[50];

#if	UNIX
        prog_name = strdup(basename(argv[0]));
#endif
	if (isatty(0) || argc > 1) {
		usage();
	}
	d1 = -2.0;
	for (;;) {
		if (fgets(buf, sizeof(buf), stdin) == NULL)
			break;
		if (!get_double_int(buf, &d2)) {
			fprintf(stderr, "%s: Error in input number.\n", prog_name);
			exit(1);
		}
		if ((d1 + 2.0) == d2) {
			printf("%.0f %.0f\n", d1, d2);
		}
		d1 = d2;
	}
	exit(0);
}

int
get_double_int(char *cp, double *dp)
{
	if (sscanf(cp, "%lf", dp) != 1) {
		return false;
	}
	if (*dp < 0.0 || fmod(*dp, 1.0) != 0.0) {
		return false;
	}
	return true;
}

void
usage()
{
	fprintf(stderr, "Usage: matho-primes | %s\n", prog_name);
	exit(1);
}
